/***************************************************************************
*   Copyright (C) 2004-2005 by Thomas Fischer                             *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#include <bibtexcomment.h>
#include <bibtexxsltransform.h>

namespace BibTeX
{

    BibTeXComment::BibTeXComment( const QString& text, bool usePercent ) : BibTeXElement(), m_text( text ), m_usePercent( usePercent )
    {
        // nothing
    }

    BibTeXComment::BibTeXComment( BibTeXComment *other )
    {
        m_text = other->m_text;
        m_usePercent = other->m_usePercent;
    }

    BibTeXComment::~BibTeXComment()
    {
        // nothing
    }

    QString BibTeXComment::text()
    {
        return m_text;
    }

    void BibTeXComment::setText( const QString &text )
    {
        m_text = text;
    }

    bool BibTeXComment::usePercent()
    {
        return m_usePercent;
    }

    void BibTeXComment::setUsePercent( bool usePercent )
    {
        m_usePercent = usePercent;
    }

    bool BibTeXComment::containsPattern( const QString& pattern, bool caseSensitive )
    {
        return m_text.find( pattern, 0, caseSensitive ) > 0;
    }

}
