/***************************************************************************
*   Copyright (C) 2004-2005 by Thomas Fischer                             *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef KBIBTEXSETTINGSSEARCHURL_H
#define KBIBTEXSETTINGSSEARCHURL_H

#include <qwidget.h>

class QLineEdit;
class QPushButton;
class QListView;
class QListViewItem;

/**
@author Thomas Fischer
*/
class KBibTeXSettingsSearchURL : public QWidget
{
    Q_OBJECT
public:
    KBibTeXSettingsSearchURL( QWidget *parent = 0, const char *name = 0 );
    ~KBibTeXSettingsSearchURL();

    void applyData();
    void setData();

signals:
    void configChanged();

private slots:
    void slotListViewExecuted( QListViewItem*item );
    void slotPushButtonAddClicked();
    void slotPushButtonDeleteClicked();
    void slotUserNameChanged( );
    void slotResetToDefaults();

private:
    void setupGUI();
    void updateGUI();

    QLineEdit *m_lineeditName;
    QLineEdit *m_lineeditSearchURL;
    QPushButton *m_pushbuttonAdd;
    QPushButton *m_pushbuttonDelete;
    QListView *m_listviewSearchURLs;
    QPushButton *m_pushbuttonResetToDefaults;
};

#endif
